CREATE TABLE JCR_CONTAINER(
  VERSION VARCHAR(96) NOT NULL PRIMARY KEY
  );
CREATE TABLE JCR_MITEM(
	ID VARCHAR(96) NOT NULL PRIMARY KEY, 
	VERSION INTEGER NOT NULL, 
	PATH VARCHAR(4096) NOT NULL
	);
CREATE UNIQUE INDEX JCR_IDX_MITEM_PATH ON JCR_MITEM(PATH, ID, VERSION);	
CREATE TABLE JCR_MNODE(
	ID VARCHAR(96) NOT NULL PRIMARY KEY, 
	ORDER_NUM INTEGER, 
	PARENT_ID VARCHAR(96), 
	CONSTRAINT JCR_FK_MNODE_PARENT FOREIGN KEY(PARENT_ID) REFERENCES JCR_MNODE(ID), 
	CONSTRAINT JCR_FK_MNODE_ITEM FOREIGN KEY(ID) REFERENCES JCR_MITEM(ID)
	);
CREATE TABLE JCR_MPROPERTY(
	ID VARCHAR(96) NOT NULL PRIMARY KEY,
	TYPE INTEGER NOT NULL, 
	PARENT_ID VARCHAR(96) NOT NULL, 
	MULTIVALUED BOOLEAN NOT NULL, 
	CONSTRAINT JCR_FK_MPROPERTY_NODE FOREIGN KEY(PARENT_ID) REFERENCES JCR_MNODE(ID), 
	CONSTRAINT JCR_FK_MPROPERTY_ITEM FOREIGN KEY(ID) REFERENCES JCR_MITEM(ID) 
	);
CREATE TABLE JCR_MVALUE(
	ID BIGINT generated by default as identity (START WITH 2, INCREMENT BY 1) NOT NULL PRIMARY KEY, 
	DATA VARBINARY(65535) NOT NULL, 
	ORDER_NUM INTEGER, 
	PROPERTY_ID VARCHAR(96) NOT NULL, 
	CONSTRAINT JCR_FK_MVALUE_PROPERTY FOREIGN KEY(PROPERTY_ID) REFERENCES JCR_MPROPERTY(ID)
	);
CREATE TABLE JCR_MREF(
  	NODE_ID VARCHAR(96) NOT NULL, 
  	PROPERTY_ID VARCHAR(96) NOT NULL,
  	ORDER_NUM INTEGER NOT NULL,
  	CONSTRAINT JCR_PK_MREF PRIMARY KEY(NODE_ID, PROPERTY_ID, ORDER_NUM),
  	CONSTRAINT JCR_CU_MREF_PROPERTY UNIQUE (PROPERTY_ID, ORDER_NUM)
);